﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;


namespace Display_Utility
{
    public partial class Form1 : Form
    {
        private Graphics Grph;
        private Bitmap Bitmp;
        private bool paint;
        private Color PaintColor;
        private Color BckColor;
        private int BrushWidth;
        private int BrushHeight;

        public Form1()
        {
            InitializeComponent();
        }

        private void InitBitMap(Color BackGround)
        {
            Bitmp = new Bitmap(pictureBox2.Width, pictureBox2.Height);
            for (int i = 0; i < pictureBox2.Height; i++)
                for (int j = 0; j < pictureBox2.Width; j++)
                    Bitmp.SetPixel(j, i, BackGround);
            Grph = Graphics.FromImage(Bitmp);
            pictureBox2.Image = Bitmp;
        }

        private void InitBitMap(Image Im)
        {
            Bitmp = new Bitmap(Im);
            Grph = Graphics.FromImage(Bitmp);
            pictureBox2.Image = Bitmp;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            textBox1.Text = pictureBox2.Size.Width.ToString();
            textBox2.Text = pictureBox2.Size.Height.ToString();
            paint = false;
            PaintColor = colorDialog1.Color;
            BckColor = Color.White;
            BrushWidth = 1;
            BrushHeight = 1;
            button3.BackColor = BackColor;
            button2.BackColor = PaintColor;
            InitBitMap(BckColor);
            
        }

        private void pictureBox2_MouseDown(object sender, MouseEventArgs e)
        {
            paint = true;
        }

        private void pictureBox2_MouseMove(object sender, MouseEventArgs e)
        {
            Xpos.Text = e.X.ToString();
            Ypos.Text = e.Y.ToString();
            
            if (paint && checkBox1.Checked)
            {
                Grph.FillRectangle(new SolidBrush(PaintColor), e.X, e.Y, BrushWidth, BrushHeight);
                pictureBox2.Image = Bitmp;
            }
        }

        private void pictureBox2_MouseUp(object sender, MouseEventArgs e)
        {
            paint = false;
        }

        private void pictureBox2_MouseClick(object sender, MouseEventArgs e)
        {
            if (paint && checkBox1.Checked)
            {
                Grph.FillRectangle(new SolidBrush(PaintColor), e.X, e.Y, BrushWidth, BrushHeight);
                pictureBox2.Image = Bitmp;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("A New Window Will Be Created !\n Do You Want To Continue?", "DISPLAY UTILITY",
              MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) != DialogResult.Cancel)
            {
                try
                {
                    pictureBox2.Size = new Size(int.Parse(textBox1.Text), int.Parse(textBox2.Text));
                    InitBitMap(BckColor);
                }
                catch (Exception)
                {
                    MessageBox.Show("Enter A Valid Width/Height", "DISPLAY UTILITY",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveFileDialog1.FileName = "";
            if (saveFileDialog1.ShowDialog() != DialogResult.Cancel)
            {
                pictureBox2.Image.Save(saveFileDialog1.FileName + ".jpg");
            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            System.Environment.Exit(System.Environment.ExitCode);
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Display Utility Program\n Developed By Nart Schinackow\nLIBSTOCK : nart_schinackow", "DISPLAY UTILITY",
                MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void textBox1_MouseClick(object sender, MouseEventArgs e)
        {
            textBox1.Clear();
        }

        private void textBox2_MouseClick(object sender, MouseEventArgs e)
        {
            textBox2.Clear();
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
        }

        private void button2_Click(object sender, EventArgs e)
        {
            
        }

       

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() != DialogResult.Cancel)
            {
                InitBitMap(Image.FromFile(openFileDialog1.FileName));
            }
        }

        private void clearToolStripMenuItem_Click(object sender, EventArgs e)
        {
            InitBitMap(BckColor);
        }

        private void chooseBrushColorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() != DialogResult.Cancel)
            {
                PaintColor = colorDialog1.Color;
                button2.BackColor = PaintColor;
            }
        }

        private void chooseBackGroundColorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() != DialogResult.Cancel)
            {
                BckColor = colorDialog1.Color;
                button3.BackColor = BckColor;
                InitBitMap(BckColor);
            }
        }

        private void textBox4_TextChanged(object sender, EventArgs e)
        {
            if (textBox4.Text != "")
            {
                try
                {
                    BrushWidth = int.Parse(textBox4.Text);
                }
                catch (Exception)
                {
                    MessageBox.Show("Enter A Valid Width/Height", "DISPLAY UTILITY",
                   MessageBoxButtons.OK, MessageBoxIcon.Error);
                    textBox4.Text = "0";
                }
            }
        }

        private void textBox3_TextChanged(object sender, EventArgs e)
        {
            if (textBox3.Text != "")
            {
                try
                {
                    BrushHeight = int.Parse(textBox3.Text);
                }
                catch (Exception)
                {
                    MessageBox.Show("Enter A Valid Width/Height", "DISPLAY UTILITY",
                   MessageBoxButtons.OK, MessageBoxIcon.Error);
                    textBox3.Text = "0";
                }
            }
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() != DialogResult.Cancel)
            {
                PaintColor = colorDialog1.Color;
                button2.BackColor = PaintColor;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() != DialogResult.Cancel)
            {
                BckColor = colorDialog1.Color;
                button3.BackColor = BckColor;
                InitBitMap(BckColor);
            }
        }

        private void saveAsByteArrayCCODEToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveFileDialog2.FileName = "";
            int RGB;
            if (saveFileDialog2.ShowDialog() != DialogResult.Cancel)
            {
                FileStream f = new FileStream(saveFileDialog2.FileName + ".txt", FileMode.Create, FileAccess.Write);
                StreamWriter writer = new StreamWriter(f);
                writer.Write("unsigned short ImageName[][]={");
                for (int row = 0; row < pictureBox2.Height; row++)
                {
                    writer.Write("{");
                    for (int col = 0; col < pictureBox2.Width; col++)
                    {
                        RGB = Bitmp.GetPixel(col, row).ToArgb() & 0x00ffffff;
                        writer.Write(RGB.ToString());
                        if (col != pictureBox2.Width - 1) writer.Write(",");
                    }
                    writer.Write("}");
                    if (row != pictureBox2.Height - 1) writer.Write(",");
                }
                writer.WriteLine("};");
                writer.Close();
                f.Close();
            }
            
        }

       
    }
}
